#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GeneratorCFG.h"
std::auto_ptr<Fish_GeneratorCFG> Fish_GeneratorCFG::msSingleton(nullptr);

int Fish_GeneratorCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GeneratorCFGData* Fish_GeneratorCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GeneratorCFGData>& Fish_GeneratorCFG::GetMapData()
{
	return mMapData;
}

void Fish_GeneratorCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GeneratorCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GeneratorCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		{
			const char* Param = element->Attribute("Param");
			std::vector<std::string> vecParam;
			boost::split(vecParam, Param, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecParam[i].c_str(), &temp))
				{
					data.mParam.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GeneratorCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GeneratorCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GeneratorCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GeneratorCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GeneratorCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readVectorInt(L, "Param", data.mParam);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GeneratorCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GeneratorCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GeneratorCFG* Fish_GeneratorCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GeneratorCFG());
	}
	return msSingleton.get();
}

void Fish_GeneratorCFG::Release()
{
	msSingleton.reset(nullptr);
}
